#!/usr/bin/env python

class BinarySearch(object):
	
	def __init__(self):
		self.NOT_FOUND = -1
		
	def binary_search(self, arr, searchValue, left, right):
		if right < left:
			return self.NOT_FOUND
		mid = (left + right) / 2
		if searchValue > arr[mid]:
			return self.binary_search(arr, searchValue, mid + 1, right)
		elif searchValue < arr[mid]:
			return self.binary_search(arr, searchValue, left, mid - 1)
		else:
			return mid

	def search(self, arr, searchValue):
		left = 0
		right = len(arr) - 1
		return self.binary_search(arr, searchValue, left, right)
 
if __name__ == "__main__":
	'''
		returns "-1" if not found
			else, returns the index of the element
	'''
	bs = BinarySearch()
	a = [1, 2, 3, 5, 9, 11, 15, 66]
	print bs.search(a, 45)