#!/usr/bin/env python

def merge(arr, first, last, middle):
	dummy_arr = []
	i = first
	j = middle + 1
	while i <= middle and j <= last:
		if arr[i] <= arr[j]:
			dummy_arr.append(arr[i])
			i += 1
		else:
			dummy_arr.append(arr[j])
			j += 1
	while i <= middle:
		dummy_arr.append(arr[i])
		i += 1
	while j <= last:
		dummy_arr.append(arr[j])
		j += 1
	for k in range(0, last-first+1):
		arr[first+k] = dummy_arr[k]

def merge_sort(arr, first, last):
	if first < last:
		middle = (first + last)/2 # divide-step
		merge_sort(arr, first, middle) # conquering left sub-array
		merge_sort(arr, middle+1, last) # conquering right sub-array
		merge(arr, first, last, middle) # merge-step

def mergesort(arr):
	merge_sort(arr, 0, len(arr)-1)
	return arr

if __name__ == "__main__":
	arr = [3, 4, 8, 0, 6, 7, 4, 2, 1, 9, 4, 5]
	print mergesort(arr)